﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using sqlserverextensions.Helper;

public partial class UserDefinedFunctions
{
    [Microsoft.SqlServer.Server.SqlFunction(DataAccess=DataAccessKind.Read)]
    public static SqlBoolean ShareConnect(SqlString driveLetter, SqlString path, SqlString username, SqlString password)
    {
        Int16 errSeverity = 16;

        try
        {
            if (System.IO.Directory.Exists(driveLetter.Value + ":\\"))
            {
                UserDefinedFunctions.ShareDisconnect(driveLetter);
            }
            System.Diagnostics.Process p = new System.Diagnostics.Process();
            p.StartInfo.UseShellExecute = false;
            p.StartInfo.CreateNoWindow = true;
            p.StartInfo.RedirectStandardError = true;
            p.StartInfo.RedirectStandardOutput = true;

            p.StartInfo.FileName = "net.exe";

            if(String.IsNullOrEmpty(username.Value) && String.IsNullOrEmpty(password.Value))
                p.StartInfo.Arguments = " use " + driveLetter.Value + ": " + path.Value;
            else
                p.StartInfo.Arguments = " use " + driveLetter.Value + ": " + path.Value + " " + password.Value + " /user:" + username.Value;
            p.Start();
            p.WaitForExit();

            string ErrorMessage = p.StandardError.ReadToEnd();
            string OuputMessage = p.StandardOutput.ReadToEnd();
            if (ErrorMessage.Length > 0)
            {
                throw new Exception("Error:" + ErrorMessage);
            }

        }
        catch (Exception ex)
        {
            ExceptionHelper.EvaluateException(ex, errSeverity);
            return false;
        }

        return true;
    }
};

